#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "rgma.h"

main(int argc, char *argv[]) {
  RGMAResource  *c;
  RGMAResultSet *rs;
  int           maxcount, endOfResults; 
  
  if (RGMA_createConsumer(3600, 
                          "SELECT * FROM userTable",
                          RGMAQueryType_CONTINUOUS, 0,
                          &c) != 0) {
    fprintf(stderr, "Failed to create consumer.\n");
    fprintf(stderr, "<%s>\n", RGMA_getException(c)->errorMessage);
    exit(1);
  }

  if (RGMAConsumer_start(c, 300) != 0) {
    fprintf(stderr, "Failed to start query.\n");
    fprintf(stderr, "<%s>\n", RGMA_getException(c)->errorMessage);
    exit(1);
  }

  maxcount=2000;

  endOfResults = 0;
  while (!endOfResults) {
    sleep(5);
    rs = RGMAConsumer_pop(c, maxcount);
    if (rs == NULL) {
      fprintf(stderr, "Failed to pop.\n");
      fprintf(stderr, "<%s>\n", RGMA_getException(c)->errorMessage);
      exit(1);
    } else {
      RGMA_printResultSet(stdout, rs);
      endOfResults = rs->endOfResults;
      RGMA_freeResultSet(rs);
    }
  }
  
  RGMA_freeResource(c);
  exit(0);
}
