import org.glite.rgma.Consumer;
import org.glite.rgma.ConsumerFactory;
import org.glite.rgma.QueryProperties;
import org.glite.rgma.RGMAException;
import org.glite.rgma.RemoteException;
import org.glite.rgma.ResultSet;
import org.glite.rgma.TimeInterval;
import org.glite.rgma.Units;
import org.glite.rgma.UnknownResourceException;
import org.glite.rgma.stubs.ConsumerFactoryStub;

public class ConsumerExample {
  public static void main(String[] args) {

    try {
      ConsumerFactory factory = new ConsumerFactoryStub();

      TimeInterval ti = new TimeInterval(60, Units.MINUTES);
      Consumer c = factory.createConsumer(ti,
                                          "SELECT * FROM userTable",
                                          QueryProperties.CONTINUOUS);

      c.start(new TimeInterval(5, Units.MINUTES));

      ResultSet rs = null;
      do {
        try {
          Thread.sleep(5 * 1000);
        } catch (InterruptedException e) {}

        rs = c.pop(2000);
        System.out.println(rs);
      } while (!rs.endOfResults());

    } catch (RemoteException e) {
      System.err.println("Failed to contact Consumer service.");
      e.printStackTrace(System.err);
      System.exit(1);
    } catch (UnknownResourceException e) {
      System.err.println("Failed to contact Consumer resource.");
      e.printStackTrace(System.err);
      System.exit(1);
    } catch (RGMAException e) {
      System.err.println("R-GMA application error in Consumer.");
      e.printStackTrace(System.err);
      System.exit(1);
    }
  }
}
