#!/usr/bin/env python

import sys, time
import rgma

try:
    
    terminationInterval = rgma.TimeInterval(60, rgma.Units.MINUTES)
    queryProperties = rgma.QueryProperties(rgma.QueryType.CONTINUOUS)
    select = "SELECT * FROM userTable"
    consumer = rgma.Consumer(terminationInterval, queryProperties, select)

    timeout = rgma.TimeInterval(300, rgma.Units.SECONDS)
    consumer.start(timeout)

    endOfResults = False
    while not endOfResults:
        time.sleep(5)
        results = consumer.pop(2000)
        for row in results:
            print row
        endOfResults = results.endOfResults

    consumer.close()

except (rgma.RGMAException, rgma.RemoteException, rgma.UnknownResourceException), e:
    print "RGMA Error: ", e
    sys.exit(1)
except:
    print "Unexpected error:", sys.exc_info()[0]
    sys.exit(1)
