#include <stdio.h>
#include <stdlib.h>

#include "rgma.h"

#define MAX_SQL 255

main(int argc, char *argv[]) {
  RGMAResource *pp;
  int          historyRP, latestRP;
  char         insert[MAX_SQL], predicate[MAX_SQL];
  
  if (argc != 2) {
    fprintf(stderr, "Usage: %s <userId>\n", argv[0]);
    exit(1);
  }

  if (RGMA_createPrimaryProducer(3600, 0, 
                                 RGMAStorageType_MEMORY,
                                 NULL, 
                                 &pp) != 0) {
    fprintf(stderr, "Failed to create producer.\n");
    fprintf(stderr, "<%s>\n", RGMA_getException(pp)->errorMessage);
    exit(1);
  }

  sprintf(predicate, "WHERE userId = '%s'", argv[1]);
  historyRP = 3600;
  latestRP = 3600;
  if (RGMAPrimaryProducer_declareTable(pp,
                                       "userTable", predicate,          
                                       historyRP,
                                       latestRP) != 0) {
    fprintf(stderr, "Failed to declare table.\n");
    fprintf(stderr, "<%s>\n", RGMA_getException(pp)->errorMessage);
    exit(1);
  }

  sprintf(insert, "INSERT INTO userTable (userId, aString, aReal, anInt) \
                   VALUES ('%s', 'C producer', 3.1415926, 42)", argv[1]);
  if (RGMAPrimaryProducer_insert(pp, insert, 0) != 0) {
    fprintf(stderr, "Failed to insert.\n");
    fprintf(stderr, "<%s>\n", RGMA_getException(pp)->errorMessage);
    exit(1);
  }

  RGMA_freeResource(pp);
  exit(0);
}
