import org.glite.rgma.PrimaryProducer;
import org.glite.rgma.ProducerFactory;
import org.glite.rgma.ProducerProperties;
import org.glite.rgma.RGMAException;
import org.glite.rgma.RemoteException;
import org.glite.rgma.Storage;
import org.glite.rgma.TimeInterval;
import org.glite.rgma.Units;
import org.glite.rgma.UnknownResourceException;
import org.glite.rgma.stubs.ProducerFactoryStub;


public class PrimaryProducerExample {
  public static void main(String[] args) {
    if (args.length != 1) {
      System.err.println("Usage: java PrimaryProducerExample <userId>");
      System.exit(1);
    }

    try {
      ProducerFactory factory = new ProducerFactoryStub();
      TimeInterval ti = new TimeInterval(60, Units.MINUTES);
      ProducerProperties props = new ProducerProperties(Storage.MEMORY, 0);
      PrimaryProducer pp = factory.createPrimaryProducer(ti, props);

      String predicate = "WHERE userId = '" + args[0] + "'";
      TimeInterval historyRP = new TimeInterval(60, Units.MINUTES);
      TimeInterval latestRP = new TimeInterval(60, Units.MINUTES);
      pp.declareTable("userTable", predicate, historyRP, latestRP);

      String insert = "INSERT INTO userTable (userId, aString, aReal, anInt)" +
           " VALUES ('" + args[0] + "', 'Java producer', 3.1415926, 42)";
      pp.insert(insert);

      pp.close();
    } catch (RemoteException e) {
      System.err.println("Failed to contact PrimaryProducer service.");
      e.printStackTrace(System.err);
      System.exit(1);
    } catch (UnknownResourceException e) {
      System.err.println("Failed to contact PrimaryProducer resource.");
      e.printStackTrace(System.err);
      System.exit(1);
    } catch (RGMAException e) {
      System.err.println("R-GMA application error in PrimaryProducer.");
      e.printStackTrace(System.err);
      System.exit(1);
    }
  }
}
