#!/usr/bin/env python

import sys, time
import rgma

terminationInterval = rgma.TimeInterval(60, rgma.Units.MINUTES)
oldData = rgma.TimeInterval(30, rgma.Units.SECONDS)
queryProperties = rgma.QueryProperties(rgma.QueryType.CONTINUOUS, oldData)
select = "SELECT * FROM userTable"

consumerCreated = False
consumerStarted = False
endOfResults = False;

while True:

   try:
    
      while not consumerCreated:
         consumer = rgma.Consumer(terminationInterval, queryProperties, select)
         consumerCreated = True

      while not consumerStarted:
         consumer.start(rgma.TimeInterval(365, rgma.Units.DAYS))
         consumerStarted = True

      while not endOfResults:
         time.sleep(5)
         resultSet = consumer.pop(2000)
         for row in resultSet:
            print row
         if resultSet.warning:
            print "WARNING: %s" % resultSet.warning.getMessage()
         endOfResults = resultSet.endOfResults

      try:
         consumer.close()
      except Exception, e:
         pass
      
      consumerCreated = False;
      consumerStarted = False;
      endOfResults = False;

   except (rgma.UnknownResourceException), e:
      sys.stderr.write("Consumer has died - will try to create a new one\n")
      consumerCreated = False
      consumerStarted = False
      endOfResults = False
      
   except (rgma.RemoteException), e:
      sys.stderr.write("Failed to contact R-GMA server: %s - will retry in 60s\n" % e)
      time.sleep(60)
      
   except (rgma.RGMAException), e:
      sys.stderr.write("Unexpected R-GMA error - exiting")
      if consumer:
         try:
            consumer.close()
         except:
            pass
      raise e
