#!/usr/bin/env python

import sys, time
import rgma

if len(sys.argv) != 2:
   sys.stderr.write("Exactly one argument must be specified\n")
   sys.exit(1)
   
data = 0
predicate =  "WHERE userId = '%s'" % sys.argv[1]
storage = rgma.Storage(rgma.StorageType.MEMORY)
properties = rgma.ProducerProperties(storage)
terminationInterval = rgma.TimeInterval(60, rgma.Units.MINUTES)
historyRP = rgma.TimeInterval(50, rgma.Units.MINUTES)
latestRP = rgma.TimeInterval(25, rgma.Units.MINUTES)

producerCreated = False
tableDeclared = False

while True:

   try:
      
      while not producerCreated:
         producer = rgma.PrimaryProducer(terminationInterval, properties)
         producerCreated = True
      
      while not tableDeclared:
         producer.declareTable("userTable", predicate, latestRP, historyRP)
         tableDeclared = True
    
      while True:
         insert = "INSERT INTO userTable (userId, aString, aReal, anInt) \
               VALUES ('%s', '', 0.0, %d)" % (sys.argv[1], data)
         producer.insert(insert)
         print insert
         data += 1
         time.sleep(30)
      
   except (rgma.UnknownResourceException), e:
      sys.stderr.write("Producer has died - will try to create a new one\n");
      producerCreated = False
      tableDeclared = False
      
   except (rgma.RemoteException), e:
      sys.stderr.write("Failed to contact R-GMA server: %s - will retry in 60s\n" % e);
      time.sleep(60)

   except (rgma.RGMABufferFullException), e:
      sys.stderr.write("Producer buffer is full - will retry insert in 60s\n");
      time.sleep(60)
      
   except (rgma.RGMAUserException), e:
      sys.stderr.write("WARNING: Invalid tuple: %s (%s)\n" % (insert, e.getMessage()))
      
   except (rgma.RGMAException), e:
      sys.stderr.write("Unexpected R-GMA error - exiting\n")
      if producer:
         try:
            producer.close()
         except:
            pass
      raise e
