#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "rgma.h"

main(int argc, char *argv[]) {
  RGMAResource       *sp;
  RGMAStorageLocation sl;
  int                 historyRP;

  sl.location = "jdbc:mysql://localhost:3306/somedatabase";
  sl.username = "fred";
  sl.password = "bloggs";
  sl.logicalName = NULL;
  if (RGMA_createSecondaryProducer(3600, 
                                   RGMAProducerProps_LATEST,
                                   RGMAStorageType_DATABASE,
                                   &sl, 
                                   &sp) != 0) {
    fprintf(stderr, "Failed to create producer.\n");
    fprintf(stderr, "<%s>\n", RGMA_getException(sp)->errorMessage);
    exit(1);
  }

  historyRP = 7200;
  if (RGMASecondaryProducer_declareTable(sp,
                                       "userTable", "",          
                                       historyRP) != 0) {
    fprintf(stderr, "Failed to declare table.\n");
    fprintf(stderr, "<%s>\n", RGMA_getException(sp)->errorMessage);
    exit(1);
  }

  while (RGMA_showSignOfLife(sp) == 0) {
    sleep(3300);
  }
  
  fprintf(stderr, "showSignOfLife failed.\n");
  fprintf(stderr, "<%s>\n", RGMA_getException(sp)->errorMessage);
  exit(1);
}
