#!/usr/bin/env python

import sys, time
import rgma

try:
    
    storage = rgma.Storage(rgma.StorageType.DATABASE, \
              "jdbc:mysql://localhost:3306/somedatabase", \
              "fred", \
              "bloggs")
    properties = rgma.ProducerProperties(storage, rgma.QueryType.LATEST)
    terminationInterval = rgma.TimeInterval(60, rgma.Units.MINUTES)
    sp = rgma.SecondaryProducer(terminationInterval, properties)

    predicate = ""
    historyRetentionPeriod = rgma.TimeInterval(2, rgma.Units.HOURS)
    sp.declareTable("userTable",
                          predicate,
                          historyRetentionPeriod)
    
    while True:
        sp.showSignOfLife()
        time.sleep(55*60)
        
except (rgma.RGMAException, rgma.RemoteException, rgma.UnknownResourceException), e:
    print "RGMA Error", e
    sys.exit(1)
except:
    print "Unexpected error:", sys.exc_info()[0]
